#def dataailability_flags(df_col):
#    import numpy as np
#    nodata = np.isnan(df_col)
#    flags = np.convolve(1 * nodata,[-1,1])[1:]
#    t1 = nodata.index[flags==1]
#    t2 = nodata.index[flags==-1]
#    return t1, t2
def dataailability_flags(df_col,daily=False):
    #df_col = df['position []']
    import numpy as np
    import pandas as pd
    if daily:
        df_col = df_col.groupby(pd.TimeGrouper(freq='1440Min')).aggregate(np.mean)
    
    df_head = pd.DataFrame([1,np.nan], index=[pd.datetime(1970,1,1,1),df_col.index[0]])
    df_tail = pd.DataFrame([np.nan, np.nan, 1], index=[df_col.index[-1], pd.datetime(2050,1,1,1), pd.datetime(2050,1,1,1)])
    df_col = pd.concat([df_head[0], df_col, df_tail[0]])
    
    nodata = np.isnan(df_col)#[1:]
    flags = np.convolve(1 * nodata,[-1,1])[1:]
    t1 = nodata.index[flags==-1]
    t2 = nodata.index[flags==1]
    return t1, t2


def nodata_rectangles(ax, t1, t2, facecolor='gray', alpha=0.5):
    import numpy as np
    import matplotlib.transforms as mtransforms
    trans = mtransforms.blended_transform_factory(ax.transData, ax.transAxes)
    for i in range(np.min([len(t1),len(t2)])):
        ax.fill_between([t1[i],t2[i]],0,1,facecolor=facecolor, alpha=alpha, transform=trans)



def colorbar_hydrologicalyears(color_list,year_list):
    import numpy as np
    import matplotlib as mpl
    import matplotlib.pyplot as plt
    from mpl_toolkits.axes_grid1 import make_axes_locatable
    divider = make_axes_locatable(plt.gca())
    ax_cb = divider.new_horizontal(size="5%", pad=0.05)    
    cmap = mpl.colors.ListedColormap(color_list)
    bounds = np.array(year_list + [year_list[-1] + 1]) - 0.25
    cb1 = mpl.colorbar.ColorbarBase(ax_cb, cmap=cmap, boundaries=bounds, ticks=year_list, orientation='vertical')
    plt.gcf().add_axes(ax_cb)